<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Cypress USB Device Middleware Library 2.0</title>
    <detaileddescription>
<para>The USB Device middleware provides a full-speed USB 2.0 Chapter 9 specification -compliant device framework. It uses the USBFS driver from PDL to interface with the hardware. The middleware provides support for Audio, CDC, and HID classes. Also, it allows implementing other class support. The USB Configurator tool makes it easy to construct the USB Device descriptor.</para><para><bold>Features:</bold><itemizedlist>
<listitem><para>USB Full-Speed Device Framework</para></listitem><listitem><para><ref kindref="member" refid="index_1group_usb_dev_cfg_tool">USB Configurator</ref></para></listitem><listitem><para>The following USB Classes are supported:<itemizedlist>
<listitem><para><ref kindref="member" refid="index_1group_usb_dev_audio_class_info">Audio Class</ref></para></listitem><listitem><para><ref kindref="member" refid="index_1group_usb_dev_cdc_class_info">CDC: Communication Device Class</ref></para></listitem><listitem><para><ref kindref="member" refid="index_1group_usb_dev_hid_class_info">HID: Human Interface Device</ref></para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para>
<para><heading level="1">General Description</heading></para>
<para>The USB Device structure is divided into layers. The implementation is event-driven: the USBFS driver receives interrupts from the hardware and provides callbacks to the USB Device layer which implements them and provides events to the Class layer. A simplified image is shown below. <linebreak />
 <linebreak />
<image name="usb_dev_solution_struct.png" type="html" />
</para><para>Include cy_usb_dev.h along with the header for the USB class to be used (cy_usb_dev_hid.h, cy_usb_dev_cdc.h, cy_usb_dev_audio.h) to get access to all the functions and other declarations in this library. If you use ModusToolbox USB Device Configurator, also include cycfg_usbdev.h.</para>

<para><heading level="1">Quick Start Guide</heading></para>
<para>Cypress USB Device middleware can be used in various software environments. Refer to the <ref kindref="member" refid="index_1section_usb_dev_toolchain">Supported Software and Tools</ref>. The quickest way to get started is using the Code Examples. Cypress Semiconductor continuously extends its portfolio of code examples at <ulink url="http://www.cypress.com">Cypress Semiconductor website</ulink> and at <ulink url="https://github.com/cypresssemiconductorco">Cypress Semiconductor GitHub</ulink>.</para><para>This quick start guide is for an environment configured to use for development PSoC 6 Peripheral Driver Library(psoc6pdl) included in the project.</para><para>To easily run a USB, use the ModusToolbox USBCommDevice or USBM project. The steps below show how to set up a USB Device based on a basic ModusToolbox project (like Hello_World).</para><para>The following steps set up a USB device recognized as an standard HID device - USB mouse and moves it from right to the left, and vice-versa. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Some steps contain a corresponding to the figure below number in brackets.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>STEP 1: Enable the USB Device middleware.</bold></para>
<para>Launch ModusToolbox Library Manager and enable the USB Device middleware. This step is required only if the ModusToolbox IDE is used. Otherwise, ensure the USB Device Middleware is included in your project.</para>

<para><bold>STEP 2: Generate initialization code.</bold></para>
<para><orderedlist>
<listitem><para>Launch the ModusToolbox Device Configurator Tool and switch to the Peripherals tab (#1.1).</para></listitem><listitem><para>Enable the USB personality under Communication and enter Alias (#1.2). We use USBHID in <ref kindref="member" refid="index_1section_usb_dev_quick_start">Quick Start Guide</ref></para></listitem><listitem><para>Go to the Parameters pane and configure the USB personality: assign the peripheral clock divider (#1.3) for Clock (Bus Reset). Any available free divider can be used.</para></listitem><listitem><para>Set Endpoint Mask to 1 to enable data endpoint 1 (#1.4) Enabled data endpoints must match the descriptor tree in the USB Configurator. <image name="usb_dev_device_cfg.png" type="html" />
</para></listitem><listitem><para>Switch to the System tab (#2.1).</para></listitem><listitem><para>Check the IMO clock is enabled (#2.2). Select Trim with USB (#2.3)</para></listitem><listitem><para>Select one of the PLLs, if your device supports more than one. Enable the PLL and set a frequency of 48 MHz (#2.4).</para></listitem><listitem><para>Select the CLK_HF3 USB clock (#2.5). Assign the source clock to the CLK_PATH connected to the configured previously PLL (#2.6).</para></listitem><listitem><para>Check the FLL clock is enabled (#2.7).</para></listitem><listitem><para>Select File-&gt;Save to generate initialization code. <image name="usb_dev_system_cfg.png" type="html" />
</para></listitem></orderedlist>
</para>

<para><bold>STEP 3: Generate USB descriptors.</bold></para>
<para><orderedlist>
<listitem><para>Run the USB Configurator.</para></listitem><listitem><para>In the Device Descriptor node, set bDeviceClass - 0x02(#3.1), iProduct - the device name to identify among connected devices. We use "USB Device Quick Start guide"(#3.2).</para></listitem><listitem><para>Remove default Alternate Settings.</para></listitem><listitem><para>Add HID Alternate Settings.</para></listitem><listitem><para>Add HID Descriptor and select 3-Button Mouse in HID Report (#3.3).</para></listitem><listitem><para>Add Endpoint Descriptor and set: direction - IN, Transfer Type - Interrupt, wMaxPacketSize - 3, bInterval - 10(#3.4).</para></listitem><listitem><para>Perform File-&gt;Save to generate initialization code. If configuration is saved for the first time, choose a name (like design.cyusbdev) and save it to the project root. <image name="usb_dev_configurator.png" type="html" />
</para></listitem></orderedlist>
</para>

<para><bold>STEP 4: Update main.c</bold></para>
<para><orderedlist>
<listitem><para>Include the USB headers to get access to the generated descriptor structures, USB driver, device, and class layers APIs. <programlisting><codeline><highlight class="preprocessor">#include<sp />"cy_pdl.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_usb_dev.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_usb_dev_audio.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_usb_dev_cdc.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_usb_dev_hid.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cycfg_usbdev.h"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cycfg.h"</highlight><highlight class="normal" /></codeline>
</programlisting></para></listitem><listitem><para>Declare the USB context global variables: <programlisting><codeline><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Global<sp />constants</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_usbfs_dev_drv_context_t<sp /><sp /><sp /><sp /><sp /><sp />USBHID_context;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />USBHID_devContext;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__hid__context__t">cy_stc_usb_dev_hid_context_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />USBHID_hidContext;</highlight></codeline>
</programlisting></para></listitem><listitem><para>Configure the USB interrupt structures and declare interrupt handlers (refer to the Configure Interrupts section of the USBFS driver in the PDL API Reference). <programlisting><codeline><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />USBFS<sp />interrupts<sp />functions<sp />and<sp />configurations</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrLow(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrMedium(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrHigh(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />USBD_IntrHighConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />(IRQn_Type)<sp />usb_interrupt_hi_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />5U,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />USBD_IntrMeduimConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />(IRQn_Type)<sp />usb_interrupt_med_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />6U,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />USBD_IntrLowConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />(IRQn_Type)<sp />usb_interrupt_lo_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />7U,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting></para></listitem><listitem><para>Implement the interrupt handlers: <programlisting><codeline><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />USBD_IsrHigh</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrHigh(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />interrupt<sp />processing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_USBFS_Dev_Drv_Interrupt(USBHID_HW,<sp />Cy_USBFS_Dev_Drv_GetInterruptCauseHi(USBHID_HW),<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;USBHID_context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />USBD_IsrMedium</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrMedium(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />interrupt<sp />processing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_USBFS_Dev_Drv_Interrupt(USBHID_HW,<sp />Cy_USBFS_Dev_Drv_GetInterruptCauseMed(USBHID_HW),<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;USBHID_context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment">*<sp />Function<sp />Name:<sp />USBD_IsrLow</highlight></codeline>
<codeline><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />USBD_IsrLow(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />interrupt<sp />processing<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />Cy_USBFS_Dev_Drv_Interrupt(USBHID_HW,<sp />Cy_USBFS_Dev_Drv_GetInterruptCauseLo(USBHID_HW),<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;USBHID_context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para></listitem><listitem><para>Update the main() function with the USB and interrupt initialization routines: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__usb__dev__enums_1ga143c13515bfded27b9dc5ebc18d4cdaf">cy_en_usb_dev_status_t</ref><sp />status;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />device<sp />hardware<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />init_cycfg_all();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />USB<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__usb__dev__functions__common_1ga12b36659b72aa85166e85323eb96e36a">Cy_USB_Dev_Init</ref>(USBHID_HW,<sp />&amp;USBHID_config,<sp />&amp;USBHID_context,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;usb_devices[0],<sp />&amp;usb_devConfig,<sp />&amp;USBHID_devContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__usb__dev__enums_1gga143c13515bfded27b9dc5ebc18d4cdafabf8d747d814384b26bf7e65e59648744">CY_USB_DEV_SUCCESS</ref><sp />!=<sp />status)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialization<sp />error<sp />-<sp />stop<sp />execution<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(1);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__usb__dev__hid__functions_1ga96ac1be9fe988572712f3111180170bb">Cy_USB_Dev_HID_Init</ref>(&amp;usb_hidConfig,<sp />&amp;USBHID_hidContext,<sp />&amp;USBHID_devContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__usb__dev__enums_1gga143c13515bfded27b9dc5ebc18d4cdafabf8d747d814384b26bf7e65e59648744">CY_USB_DEV_SUCCESS</ref><sp />!=<sp />status)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />HID<sp />Initialization<sp />error<sp />-<sp />stop<sp />execution<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(1);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Hook<sp />interrupt<sp />service<sp />routines<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrLowConfig,<sp /><sp /><sp /><sp />&amp;USBD_IsrLow);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrMeduimConfig,<sp />&amp;USBD_IsrMedium);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrHighConfig,<sp /><sp /><sp />&amp;USBD_IsrHigh);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrLowConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrMeduimConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrHighConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />__enable_irq();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Make<sp />device<sp />appear<sp />on<sp />the<sp />bus<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref>(</highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><ref kindref="member" refid="group__group__usb__dev__macros_1gad8a978b86bb53dd8e46d9f9db9399ee8">CY_USB_DEV_WAIT_FOREVER</ref>,<sp />&amp;USBHID_devContext);</highlight></codeline>
</programlisting></para></listitem><listitem><para>Example of the routine to move mouse from right to the left, and vice-versa. <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />CURSOR_X_POS<sp /><sp /><sp /><sp /><sp />=<sp /><sp /><sp />1UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />MOUSE_DATA_LEN<sp /><sp /><sp />=<sp /><sp /><sp />3UL;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />MOUSE_IN_EP<sp /><sp /><sp /><sp /><sp /><sp />=<sp /><sp /><sp />1UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp /><sp />CURSOR_STEP<sp /><sp /><sp /><sp /><sp /><sp />=<sp /><sp /><sp />5U;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />STEPS_NUMBER<sp /><sp /><sp /><sp /><sp />=<sp /><sp /><sp />96UL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />counter<sp />=<sp />0U;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />moveRight<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Mouse<sp />packet<sp />array:<sp />buttons<sp />(1st<sp />byte),<sp />X<sp />(2nd<sp />byte),<sp />Y<sp />(3rd<sp />byte)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__usb__dev__macros_1ga0ccd70a937ab3d69aeb40030713bc69b">CY_USB_DEV_ALLOC_ENDPOINT_BUFFER</ref>(mouseData,<sp />3U);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />mouseData[2U]<sp />=<sp />0U;<sp /></highlight><highlight class="comment">/*<sp />No<sp />changes<sp />in<sp />Y<sp />-<sp />position<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(;;)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Move<sp />mouse<sp />to<sp />the<sp />right<sp />or<sp />to<sp />the<sp />left<sp />appropriate<sp />number<sp />of<sp />steps<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mouseData[CURSOR_X_POS]<sp />=<sp />moveRight<sp />?<sp />CURSOR_STEP<sp />:<sp />(uint8_t)-CURSOR_STEP;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Define<sp />direction<sp />of<sp />the<sp />movement<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0U<sp />==<sp />counter)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />counter<sp />=<sp />STEPS_NUMBER;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />moveRight<sp />=<sp />!moveRight;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Update<sp />mouse<sp />position<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__usb__dev__functions__data__transfer_1ga1bf916540d58d458568b2eed1a186df4">Cy_USB_Dev_WriteEpBlocking</ref>(MOUSE_IN_EP,<sp />mouseData,<sp />MOUSE_DATA_LEN,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__usb__dev__macros_1gad8a978b86bb53dd8e46d9f9db9399ee8">CY_USB_DEV_WAIT_FOREVER</ref>,<sp />&amp;USBHID_devContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />counter--;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysLib_Delay(10UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting> </para></listitem></orderedlist>
</para>

<para><bold>STEP 5: Build and program the device.</bold></para>
<para>Connect the device to the Host PC. On the PC, verify a new USB device was enumerated as a mouse device. The mouse’s cursor shall move left to right and vice-versa.</para>


<para><heading level="1">Configuration Considerations</heading></para>
<para>This section explains how to configure the USB Device for operation.</para>
<para><bold>Configure USBFS driver</bold></para>
<para>The driver and system resources configuration details are provided in the USBFS driver section Configuration Considerations in the PDL API Reference Manual. The provided code snippets expect that driver and system resources configuration is done.</para>

<para><bold>Construct USB Device Descriptors</bold></para>
<para>Run standalone USB Configurator tool to construct the USB Device descriptors. After USB Device descriptors are constructed, save generated source and header files. Add these files to your project. Open header files to get external definitions for:<itemizedlist>
<listitem><para>USB Device configuration structure <ref kindref="compound" refid="structcy__stc__usb__dev__config__t">cy_stc_usb_dev_config_t</ref> instance.</para></listitem><listitem><para>Array of USB Devices structures <ref kindref="compound" refid="structcy__stc__usb__dev__device__t">cy_stc_usb_dev_device_t</ref>.</para></listitem><listitem><para>CDC and/or HID class configuration structure instances.</para></listitem></itemizedlist>
</para><para>These definitions will be required in the configuration steps provided below.</para>

<para><bold>Configure USB Device</bold></para>
<para>To initialize the USB Device middleware, call <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga12b36659b72aa85166e85323eb96e36a">Cy_USB_Dev_Init</ref> function providing:<itemizedlist>
<listitem><para>The pointer to the USBFS instance.</para></listitem><listitem><para>The pointer to the filled USBFS driver configuration structure cy_stc_usbfs_dev_drv_config_t.</para></listitem><listitem><para>The pointer to the allocated USBFS driver context structure cy_stc_usbfs_dev_drv_context_t.</para></listitem><listitem><para>The pointer to the generated middleware USB Device structure <ref kindref="compound" refid="structcy__stc__usb__dev__device__t">cy_stc_usb_dev_device_t</ref>.</para></listitem><listitem><para>The pointer to the generated middleware USB Device configuration structure <ref kindref="compound" refid="structcy__stc__usb__dev__config__t">cy_stc_usb_dev_config_t</ref>.</para></listitem><listitem><para>The pointer to the allocated middleware USB Device context structure <ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref>.</para></listitem></itemizedlist>
</para>

<para><bold>Configure USB Classes</bold></para>
<para>The USB Device middleware provides support of Audio, HID, and CDC classes. Each class has own initialization function. This function must be called after <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga12b36659b72aa85166e85323eb96e36a">Cy_USB_Dev_Init</ref> to initialize class data and register it. The class-specific request will be passed to the class handler after registration. Note that the USB Configurator tool generates HID and CDC Class configuration structures that are required class initialization. Find these structure external declaration in the generated header file.</para><para>To initialize the Audio Class, call <ref kindref="member" refid="group__group__usb__dev__audio__functions_1ga8224694c94d72e5c3e2d717bd3a70f3c">Cy_USB_Dev_Audio_Init</ref> function providing:<itemizedlist>
<listitem><para>The NULL pointer (reserved for possible future use).</para></listitem><listitem><para>The pointer to the allocated Audio Class context structure <ref kindref="compound" refid="structcy__stc__usb__dev__audio__context__t">cy_stc_usb_dev_audio_context_t</ref>.</para></listitem><listitem><para>The pointer to the allocated USB Device context structure <ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref>.</para></listitem></itemizedlist>
</para><para>To initialize the CDC Class, call <ref kindref="member" refid="group__group__usb__dev__cdc__functions_1ga674860e659c0f23538a9f6c11e64b03a">Cy_USB_Dev_CDC_Init</ref> function providing:<itemizedlist>
<listitem><para>The pointer to the populated CDC Class configuration structure <ref kindref="compound" refid="structcy__stc__usb__dev__cdc__config__t">cy_stc_usb_dev_cdc_config_t</ref>.</para></listitem><listitem><para>The pointer to the allocated CDC Class context structure <ref kindref="compound" refid="structcy__stc__usb__dev__cdc__context__t">cy_stc_usb_dev_cdc_context_t</ref>.</para></listitem><listitem><para>The pointer to the allocated USB Device context structure <ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref>.</para></listitem></itemizedlist>
</para><para>To initialize the HID Class, call <ref kindref="member" refid="group__group__usb__dev__hid__functions_1ga96ac1be9fe988572712f3111180170bb">Cy_USB_Dev_HID_Init</ref> function providing:<itemizedlist>
<listitem><para>The pointer to the populated HID Class configuration structure <ref kindref="compound" refid="structcy__stc__usb__dev__hid__config__t">cy_stc_usb_dev_hid_config_t</ref>.</para></listitem><listitem><para>The pointer to the allocated HID Class context structure <ref kindref="compound" refid="structcy__stc__usb__dev__hid__context__t">cy_stc_usb_dev_hid_context_t</ref>.</para></listitem><listitem><para>The pointer to the allocated USB Device context structure <ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref>.</para></listitem></itemizedlist>
</para>

<para><bold>Enable USB Device</bold></para>
<para>Finally, enable the USB Device operation calling <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref>. This function call enables pull-up on D+ to signal USB Device connection on USB Bus. The USB Host detects device connection and starts device enumeration. It requests the device descriptors to define device capabilities and finally sets device configuration for the following operation. The <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref> provides an argument to block until enumeration completes or exits after the USB Device is enabled.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />required<sp />context<sp />structures<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_stc_usbfs_dev_drv_context_t<sp />USBD_drvContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__context__t">cy_stc_usb_dev_context_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp />USBD_devContext;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__audio__context__t">cy_stc_usb_dev_audio_context_t</ref><sp />USBD_audioContext;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__cdc__context__t">cy_stc_usb_dev_cdc_context_t</ref><sp /><sp /><sp />USBD_cdcContext;</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__usb__dev__hid__context__t">cy_stc_usb_dev_hid_context_t</ref><sp /><sp /><sp />USBD_hidContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />USB<sp />Device<sp />(status<sp />is<sp />ignored<sp />for<sp />code<sp />simplicity)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__usb__dev__functions__common_1ga12b36659b72aa85166e85323eb96e36a">Cy_USB_Dev_Init</ref>(USBD_HW,<sp />&amp;USBD_config,<sp />&amp;USBD_drvContext,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;usb_devices[0],<sp />&amp;usb_devConfig,<sp />&amp;USBD_devContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />requires<sp />USB<sp />Device<sp />Classes<sp />(status<sp />is<sp />ignored<sp />for<sp />code<sp />simplicity)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__usb__dev__audio__functions_1ga8224694c94d72e5c3e2d717bd3a70f3c">Cy_USB_Dev_Audio_Init</ref>(NULL,<sp />&amp;USBD_audioContext,<sp />&amp;USBD_devContext);</highlight></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__usb__dev__cdc__functions_1ga674860e659c0f23538a9f6c11e64b03a">Cy_USB_Dev_CDC_Init</ref>(&amp;usb_cdcConfig,<sp />&amp;USBD_cdcContext,<sp />&amp;USBD_devContext);</highlight></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__usb__dev__hid__functions_1ga96ac1be9fe988572712f3111180170bb">Cy_USB_Dev_HID_Init</ref>(&amp;usb_hidConfig,<sp />&amp;USBD_hidContext,<sp />&amp;USBD_devContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Hook<sp />interrupt<sp />service<sp />routines<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrLowConfig,<sp /><sp /><sp /><sp />&amp;USBD_IsrLow);</highlight></codeline>
<codeline><highlight class="normal">(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrMeduimConfig,<sp />&amp;USBD_IsrMedium);</highlight></codeline>
<codeline><highlight class="normal">(void)<sp />Cy_SysInt_Init(&amp;USBD_IntrHighConfig,<sp /><sp /><sp />&amp;USBD_IsrHigh);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrLowConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrMeduimConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ((IRQn_Type)<sp />USBD_IntrHighConfig.intrSrc);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">__enable_irq();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Make<sp />USB<sp />device<sp />appear<sp />on<sp />the<sp />bus<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref>(</highlight><highlight class="keyword">true</highlight><highlight class="normal">,<sp /><ref kindref="member" refid="group__group__usb__dev__macros_1gad8a978b86bb53dd8e46d9f9db9399ee8">CY_USB_DEV_WAIT_FOREVER</ref>,<sp />&amp;USBD_devContext);</highlight></codeline>
</programlisting> <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The interrupts are mandatory for the USB Device operation. Therefore, USBFS interrupts must be enabled in the NVIC and global interrupts must be enabled as well.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>


<para><heading level="1">Design Considerations</heading></para>
<para>The typical use case is that application calls the middleware API interface provided by the USB Device or Class layer to implement application logic. However, some features are provided only by the USBFS driver layer. Therefore, if the application needs them, the driver API interface must be used. The list of these features is provided in the section <ref kindref="member" refid="index_1group_usb_dev_drv_features">Driver Features</ref>.</para>
<para><bold>USB Configurator</bold></para>
<para>The standalone USB Configurator tool helps construct USB Device descriptors. The USB device descriptors provide to the USB Host complete information about the connected device. The tool output are generated source and header files that contain information about the USB Device: device descriptors plus structures that help access device descriptors. Generated files are mandatory for the middleware operation and must be added to your project. The header file provides access to instances of the USB Device configuration structure <ref kindref="compound" refid="structcy__stc__usb__dev__config__t">cy_stc_usb_dev_config_t</ref> and array of the USB Device structures <ref kindref="compound" refid="structcy__stc__usb__dev__device__t">cy_stc_usb_dev_device_t</ref>. Both these definitions are required for USB Device configuration. The tool also generates instances of configuration structures required for CDC and HID Class configuration.</para><para>A detailed information about USB Descriptors is provided by the <ulink url="http://www.usb.org/developers/docs/usb20_docs/">USB Specification</ulink></para><para>The USB Configurator tool provides the User Guide, which can be found in the documentation.</para>

<para><bold>Standard Request Support</bold></para>
<para>The USB Device supports standard requests listed in the table below.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Standard Request&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Request Processing Description&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;USB Spec Reference &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CLEAR_FEATURE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Clears or disables a specific feature. Support recipients: Device, Interface and Endpoint. The TEST_MODE feature selector is not supported. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_CONFIGURATION &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Returns the current device configuration value. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.2  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_DESCRIPTOR &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Returns the specified descriptor if the descriptor exists. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.3  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_INTERFACE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Returns the selected alternate interface setting for the specified interface. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.4  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_STATUS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Returns status for the specified recipient. Support recipients: Device, Interface, and Endpoint. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.5  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_ADDRESS &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Sets the device address for all future device accesses. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.6  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_CONFIGURATION &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Sets the device configuration. After this request, the device is ready for communication. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.7  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_DESCRIPTOR &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Not supported (optional request). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.8  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_FEATURE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enables a specific feature. Support recipients: Device, Interface, and Endpoint. The TEST_MODE feature selector is not supported. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.9  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_INTERFACE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the USB Host to select an alternate setting for the specified interface. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.10  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SYNCH_FRAME &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Not supported. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;9.4.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><bold>Audio Class</bold></para>
<para>The USB Audio class can be used in a large amount of applications, either Made for iPod (MFI) or general USB Audio based. These applications consist of, but are not limited to, speakers, microphones, headsets, music creation tools (DJ equipment, guitar jacks, etc), and mixers. An additional application for the Audio class is in Musical Instrument Digital Interface (MIDI) applications. This interface uses a digital UART-like interface and allows the information to be sent across to the Host to be used with software applications, such as Apple Garage Band. Various instruments, such as electronic pianos, interface with MIDI.</para><para>A detailed description about Audio Class is provided by the <ulink url="http://www.usb.org/developers/docs/devclass_docs/">USB Implementers Forum (USB-IF) Class Documentation</ulink></para><para>The Audio Class does not provide support any of Audio v1.0 or v2.0 requests processing and provides only the API interface to register Audio request handlers implemented on the application level. However, <ref kindref="member" refid="index_1group_usb_dev_cfg_tool">USB Configurator</ref> supports Audio v1.0 or v2.0 descriptors.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The MIDI Class support is not available in this version.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>CDC: Communication Device Class</bold></para>
<para>Common use case for this class in a PSoC design is to replace a legacy serial (RS232) COM port with a USB connection. This allows customers to use legacy serial software while updating the communication interface to something more readily available on today's computers. The type of data that might be streamed across USB can vary depending on the end application. This could be as simple as streaming raw ADC counts to an entire command protocol. Additionally, CDC is extremely useful for debug purposes. Users can easily develop a USB interface that can send and receive information across CDC. On the Host side, GUI applications are widely available to view the data being transmitted, such as TeraTerm, Terminal, or Hyper-Terminal (depending on version of Microsoft Windows).</para><para>A detailed description about CDC class is provided by the <ulink url="http://www.usb.org/developers/docs/devclass_docs/">USB Implementers Forum (USB-IF) Class Documentation</ulink></para><para>The CDC Class supports requests listed in the table below. <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Class Request&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Request Processing Description&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Communications Class Subclass Specification for PSTN Devices &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_LINE_CODING &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the host to specify typical asynchronous line-character formatting properties such as: data terminal rate, number of stop bits, parity type and number of data bits. It applies to data transfers both from the Host to the Device and from the Device to the Host. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.3.10  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_LINE_CODING &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the host to discover the currently configured line coding. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.3.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_CONTROL_LINE_STATE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Generates RS-232/V.24 style control signals - RTS and DTR. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.3.12  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para><para>The CDC Class supports notifications listed in the table below. <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Class Notification&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Notification Processing Description&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Communications Class Subclass Specification for PSTN Devices &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SERIAL_STATE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the Host to read the current state of the carrier detect (CD), DSR, break, and ring signal (RI). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.3.4  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><bold>HID: Human Interface Device</bold></para>
<para>There are many possible use cases for HID depending on the end application. A keyboard/keypad is a common HID application that has been implemented previously with PSoC. Additionally, customers can use PSoC to implement a PC mouse or game controller device. A more generic use case seen is with regards to customers using USB as general-purpose interface between PSoC and the Host, without conforming to specific USAGE such as a Keyboard, Mouse, etc. Instead the user configures the HID descriptor to be a generic device, which allows them to transfer Vendor-Specific information, such as ADC data, button presses, etc., across the HID protocol. This allows customers to perform custom/generic data transfers over USB, without needing to provide an INF or SYS file during enumeration or worry about WHQL certification. All this is accomplished using the HID drivers that are built into all modern operation systems today. This includes Windows, Mac, and Linux.</para><para>A detailed description about HID is provided by the <ulink url="http://www.usb.org/developers/docs/devclass_docs/">USB Implementers Forum (USB-IF) Class Documentation</ulink></para><para>The HID Class supports requests listed in the table below. <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Class Request&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Request Processing Description&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;HID Spec Reference &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_REPORT &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the USB Host to receive a report via the control pipe. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_REPORT &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Allows the USB Host to send a report via the control pipe (set a state of input, output, or feature report controls). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.2  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_IDLE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Reads the current idle rate for a particular Input report. &lt;br /&gt; The recommended default idle rate (rate when the device is initialized) is 500 milliseconds for keyboards (delay before first repeat rate) and infinity for joysticks and mice. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.3  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_IDLE &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Sets idle rate for a particular report. This request is used to limit the reporting frequency of an interrupt in endpoint.&lt;br /&gt; When the idle rate byte is 0 (zero), the duration is indefinite. The endpoint reports only when a change is detected in the report data. When the idle rate byte is non-zero, then a fixed duration is used (defined by idle rate). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.4  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GET_PROTOCOL &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Reads which protocol is currently active (either the boot or the report protocol). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.5  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;SET_PROTOCOL &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Switches between the boot protocol and the report protocol (or vice versa). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.6  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><bold>Adding Custom Class</bold></para>
<para>The USB Device middleware provides API interface that allows the user to implement custom class support. The middleware notifies registered class about following events:<itemizedlist>
<listitem><para>Bus Reset detected ( <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1gab6f8a0de15b09fe6a39e6d8032069a62">cy_cb_usb_dev_bus_reset_t</ref> ).</para></listitem><listitem><para>Set Configuration request received ( <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1ga18e8445fcb1392dd424ae65a726c4bd6">cy_cb_usb_dev_set_config_t</ref> ).</para></listitem><listitem><para>Set Interface request received ( <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1gaba4c41daa173f3dfc3a60c2260d1f0c1">cy_cb_usb_dev_set_interface_t</ref> ).</para></listitem><listitem><para>Setup packet received ( <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1ga3a7649a1c575110ac8e4480d70da8c2c">cy_cb_usb_dev_request_received_t</ref> ).</para></listitem><listitem><para>Data is received in response for current setup packet ( <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1ga626db28aeab6dfd0f7004866225bb0ee">cy_cb_usb_dev_request_cmplt_t</ref> ).</para></listitem></itemizedlist>
</para><para>To create a new custom Class, follow the steps below:<orderedlist>
<listitem><para>Implement functions to service events (from the list above) required for class operation. Typically, class should implement service of class-specific requests therefore needs to implement functions defined by <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1ga3a7649a1c575110ac8e4480d70da8c2c">cy_cb_usb_dev_request_received_t</ref> and <ref kindref="member" refid="group__group__usb__dev__structures__func__ptr_1ga626db28aeab6dfd0f7004866225bb0ee">cy_cb_usb_dev_request_cmplt_t</ref>.</para></listitem><listitem><para>Initialize instance of <ref kindref="compound" refid="structcy__stc__usb__dev__class__t">cy_stc_usb_dev_class_t</ref> structure using implemented service functions. Provide NULL pointer as function pointer if class does not use this event.</para></listitem><listitem><para>Allocate instance of <ref kindref="compound" refid="structcy__stc__usb__dev__class__ll__item__t">cy_stc_usb_dev_class_ll_item_t</ref> structure to provide storage for a linked list item of the class.</para></listitem><listitem><para>The class might need a context to store class-specific data. If needed, define context type specific for this class and allocate it.</para></listitem><listitem><para>To enable class operation, this needs to be registered using <ref kindref="member" refid="group__group__usb__dev__functions__class__support_1ga7796c2ddd1f1bb389cbad19acdeb5c9a">Cy_USB_Dev_RegisterClass</ref> function after USB Device middleware is initialized.</para></listitem></orderedlist>
</para><para>Any of supported classes can be taken as an example to implement a custom class.</para>

<para><bold>Vendor-Specific Requests Support</bold></para>
<para>The vendor-specific requests are STALLed by USB Device middleware by default. The exception is MS OS String vendor-specific request to retrieve an OS Feature Descriptor (Note that USB device must contain MS OS String descriptor to handle this vendor-specific by middleware). The middleware provides the <ref kindref="member" refid="group__group__usb__dev__functions__vendor__support_1gad864982cf48ad57727e40d9e9fc3e239">Cy_USB_Dev_RegisterVendorCallbacks</ref> function to register callbacks to handle vendor-specific requests.</para>

<para><bold>Allocate Data Endpoint Buffer</bold></para>
<para>The application allocates buffers for data endpoints to operate. The buffer allocation depends on USBFS driver endpoint buffer access type configuration. It specifies which hardware register set 8-bit or 16-bit is used to access hardware endpoints buffer. The 16-bit access requires that the specific rules for the endpoints buffer allocation must be met (See Hardware Buffer Access section of the USBFS driver for more information). <linebreak />
To make endpoint buffer allocation configuration independent, use the <ref kindref="member" refid="group__group__usb__dev__macros_1ga0ccd70a937ab3d69aeb40030713bc69b">CY_USB_DEV_ALLOC_ENDPOINT_BUFFER</ref> macro.</para>

<para><bold>Self-Powered Devices</bold></para>
<para>The USB Device responds to GET_STATUS requests based on the status set with the <ref kindref="member" refid="group__group__usb__dev__functions__service_1ga082afaccf8f10762300cfb1c996290fc">Cy_USB_Dev_SetPowerStatus</ref> function. To set the correct status, <ref kindref="member" refid="group__group__usb__dev__functions__service_1ga082afaccf8f10762300cfb1c996290fc">Cy_USB_Dev_SetPowerStatus</ref> must be called during initialization if USB Device is configured as self-powered. The <ref kindref="member" refid="group__group__usb__dev__functions__service_1ga082afaccf8f10762300cfb1c996290fc">Cy_USB_Dev_SetPowerStatus</ref> must be called any time the device changes status. A self-powered device also requires monitoring VBUS to control pull-up resistors. The pull-up resistor does not supply power to the data line until you call <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref>. <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga15cde7caa00a43d253198ea70935e47c">Cy_USB_Dev_Disconnect</ref> disconnects the pull-up resistor from the data line. Find information about how to add VBUS monitoring in your application in the USBFS driver section VBUS Detection in the PDL API Reference Manual.</para>

<para><bold>Timeout Function Redefinition</bold></para>
<para>The USB Device middleware provides following blocking functions: <ref kindref="member" refid="group__group__usb__dev__functions__data__transfer_1ga0ffcc053f1154d6f77b1744f7a517ef5">Cy_USB_Dev_ReadEpBlocking</ref>, <ref kindref="member" refid="group__group__usb__dev__functions__data__transfer_1ga1bf916540d58d458568b2eed1a186df4">Cy_USB_Dev_WriteEpBlocking</ref>, and <ref kindref="member" refid="group__group__usb__dev__functions__common_1ga368f2e081a58b7eef81a17c4781fca8e">Cy_USB_Dev_Connect</ref> (the behavior defined by the blocking parameter of the connect function). The blocking functions parameter timeout defines how many milliseconds to wait before timeout. The SysLib driver function Cy_SysLib_Delay is used to implement a 1 millisecond wait cycle. The middleware provides function <ref kindref="member" refid="group__group__usb__dev__functions__data__transfer_1ga17873db332970f17f9cfa8b7f383c019">Cy_USB_Dev_OverwriteHandleTimeout</ref> that allows overriding the wait function implementation. This might be useful when an operation system is used in your application.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The blocking function must be used carefully to not cause application lock-up. The preferred solution is using non-blocking functions.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Driver Features</bold></para>
<para>There are driver features that do not have corresponding an API interface provided in the middleware. However, the application might need these features for USB Device implementation. If there is such a need, the driver functions must be used. These features are listed below:<itemizedlist>
<listitem><para>Data Endpoint 1 - 8 Completion, SOF received and LPM transfer ACKed events notification.</para></listitem><listitem><para>Low power support: Suspend / Resume, Remote wakeup signaling.</para></listitem><listitem><para>Link Power Management (LPM) support.</para></listitem></itemizedlist>
</para><para>Find more information in the appropriate section of the USBFS driver documentation provided in the PDL API Reference Manual.</para>


<para><heading level="1">Supported Software and Tools</heading></para>
<para>This version of the USB Device Middleware was validated for the compatibility with the following Software and Tools:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Software and Tools &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Version  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;ModusToolbox Software Environment &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox USB Device Personality in Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;- ModusToolbox USB Device Configurator &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;PSoC6 Peripheral Driver Library (PDL) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.3.0  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;GCC Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;7.2.1  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;IAR Compiler &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;8.32  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;ARM Compiler 6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;6.11  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The MISRA-C Compliant verification is not performed for Beta release. <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast involving pointers is conducted with caution that the pointers are correctly aligned for the type of object being pointed to.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.5 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast shall not be performed that removes any const or volatile qualification from the type addressed by a pointer.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;All device descriptors are stored in flash. On the USB Host get descriptor request, the pointer to descriptor is assigned to a pointer that manages data transfer losing const qualification. Despite the qualification being lost, the middleware does not perform any write access using this pointer.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Some device characteristics are stored in volatile variables. On the USB Host request, the pointer to a characteristic variable is assigned to a pointer that manages data transfer losing volatile qualification. Despite the qualification being lost, this does not cause any negative impact because the data transfer is managed by the interrupt handler. The same happens when these variables are passed as parameters to memcpy or memset function.   &lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;14.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A function shall have a single point of exit at the end of the function. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The functions can return from several points. This is typically done to improve code clarity when returning error status code if input parameters validation fails.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;16.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A pointer parameter in a function prototype should be declared as a pointer to const if the pointer is not used to modify the addressed object. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The usbfs driver and middleware defines general function prototypes and pointers to functions types but the function's implementation depends on configuration. Therefore, some functions' implementation require parameters to be pointers to const. This is not met because of the generalized implementation approach.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Errata</heading></para>
<para>This section lists the known problems with the USB Device middleware.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Cypress ID&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Known Issue&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Workaround &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;DRIVERS-1401 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The USB Device ignores LPM requests after wake up from Deep Sleep.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Call USBFS driver Cy_USBFS_Dev_Drv_Lpm_SetResponse() after calling Cy_USBFS_Dev_Drv_Resume() to restore response to the LPM packets.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;DRIVERS-1427 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The USB Device modes with DMA do not work after wake up from Deep Sleep, due to incorrect restore of the ARB_CFG register.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Save ARB_CFG values before entering Deep Sleep and restore it after calling of Cy_USBFS_Dev_Drv_Resume. &lt;div class="highlight-default notranslate"&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;/*&lt;span /&gt;Read&lt;span /&gt;and&lt;span /&gt;save&lt;span /&gt;value&lt;span /&gt;of&lt;span /&gt;ARB_CFG&lt;span /&gt;register&lt;span /&gt;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;*&lt;span /&gt;USBD_HW&lt;span /&gt;is&lt;span /&gt;a&lt;span /&gt;pointer&lt;span /&gt;to&lt;span /&gt;the&lt;span /&gt;base&lt;span /&gt;address&lt;span /&gt;of&lt;span /&gt;USBFS&lt;span /&gt;Device&lt;span /&gt;*/&lt;/pre&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;uint32_t&lt;span /&gt;tempReg&lt;span /&gt;=&lt;span /&gt;USBFS_DEV_ARB_CFG(USBD_HW);&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;/*&lt;span /&gt;Entering&lt;span /&gt;Deep&lt;span /&gt;Sleep&lt;span /&gt;*/&lt;/pre&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;/*&lt;span /&gt;Resume&lt;span /&gt;after&lt;span /&gt;Deep&lt;span /&gt;Sleep&lt;span /&gt;*/&lt;/pre&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;Cy_USBFS_Dev_Drv_Resume(USBD_HW,&lt;span /&gt;&amp;amp;USBD_context);&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;/*&lt;span /&gt;Restore&lt;span /&gt;ARB_CFG&lt;span /&gt;register&lt;span /&gt;after&lt;span /&gt;deep&lt;span /&gt;sleep&lt;span /&gt;*/&lt;/pre&gt;&lt;pre /&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;USBFS_DEV_ARB_CFG(USBD_HW)&lt;span /&gt;&amp;amp;=&lt;span /&gt;(~USBFS_USBDEV_ARB_CFG_CFG_CMP_Msk);&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;USBFS_DEV_ARB_CFG(USBD_HW)&lt;span /&gt;=&lt;span /&gt;tempReg;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;(void)&lt;span /&gt;USBFS_DEV_ARB_CFG(USBD_HW);&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre /&gt;&lt;/div&gt;&lt;/div&gt;   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the internal processing to support USBFS driver updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The USBFS driver is updated to v2.0.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Moved the timeout from &lt;a href="group__group__usb__dev__functions__data__transfer.html#group__group__usb__dev__functions__data__transfer_1gafe804a021cfbea888a966b8cf1b4172e"&gt;Cy_USB_Dev_AbortEpTransfer()&lt;/a&gt; to the driver layer. The maximum function's wait time is significantly reduced. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Align with the changes of the USBFS driver.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the functions parameter name and the structure member name class to classObj. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixed the ambiguity related to the usage of the C++ keyword class as a name.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Enclosed middleware sources within a conditional compilation to exclude the USB Device middleware for devices without USB hardware. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixed a compilation error for devices without USB hardware.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the major and minor version defines to follow the naming convention. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>For more detail, refer to the following documents:</para><para><itemizedlist>
<listitem><para><ulink url="https://cypresssemiconductorco.github.io/psoc6pdl/pdl_api_reference_manual/html/index.html">PSoC 6 Peripheral Driver Library API Reference</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox Software Environment, Quick Start Guide, Documentation, and Videos</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/Code-Examples-for-the-ModusToolbox-PSoC-6-SDK">PSoC 6 SDK Examples</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxUSBConfig">ModusToolbox USB Configurator Tool Guide</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/ModusToolboxDeviceConfig">ModusToolbox Device Configurator Tool Guide</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/cy8ckit-062-wifi-bt">PSoC 6 WiFi-BT Pioneer Kit</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/cy8cproto-062-4343w">PSoC 6 Wi-Fi BT Prototyping Kit</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/psoc6ds">PSoC 6 MCU Datasheets</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/psoc6an">PSoC 6 MCU Application Notes</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/psoc6trm">PSoC 6 MCU Technical Reference Manuals</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com">Cypress Semiconductor</ulink></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The links to the other software component’s documentation (middleware and PDL) point to GitHub to the software latest available version. To get documentation of the specified version, download from GitHub and unzip the component archive. The documentation is available in the &lt;i&gt;docs&lt;/i&gt; folder. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>